#!/bin/bash
#
# enable_sso.sh
#
# Webserver fuer SSO ueber Proxy auf Port 11974 einrichten
#
###################################################################
#
if [[ -f /etc/unix2web/uls443.conf ]]; then
  . /etc/unix2web/uls443.conf
elif [[ -f /etcunix2web/uls80.conf ]]; then
  . /etcunix2web/uls80.conf
else
  echo "Error /etc/unix2web/uls443.conf und /etcunix2web/uls80.conf nicht gefunden"
  exit 1
fi
#
if [[ -z "U2WHOME" ]]; then
  echo "Error U2WHOME nicht definiert"
  exit 1
fi
#
if [[ -z "$1" || ( "$2" != "http" && "$2" != "https" ) || -z "$3" ]]; then
  echo "usage: $(basename $0) <http-parname> http|https <proxy-ips>"
  echo
  echo "<http-parname>: HTTP-Headername für Username"
  echo "http|https    : Verbindung des Proxies zum ULS per HTTP oder HTTPS"
  echo "<proxy-ips>   : IP-Adressen der Proxy Server durch Leerzeichen getrennt"
  echo
  echo "Beispiel: enable_sso.sh REMOTE_USER https 10.11.12.13"
  exit 1
fi
#
remoteuser="$1"
httpm="$2"
shift 2
#
[[ -d ${U2WHOME%user}ulssso ]] && mv ${U2WHOME%user}ulssso ${U2WHOME%user}ulssso.pre_$(date '+%F')
cp -a $U2WHOME ${U2WHOME%user}ulssso
for i in $*; do
  echo "r $i"
done >${U2WHOME%html*}ssohosts.lst
#
if cd ${U2WHOME%user}ulssso; then
  rm logincheck.i2w loginpage.i2w login.u2w change_pwd.* check_change_pwd.i2w operator/change_pwd.* operator/check_change_pwd.i2w
  sed -i '/%include logincheck.i2w/,/%include loginpage.i2w/s/,pwddaysexpire,pwdflags,rights,wrongpwd/,rights/
/%include logincheck.i2w/,/%include loginpage.i2w/s/%cpar('"'username')/%hpar('$remoteuser')/
/ *if(not find_in_set('notexpire'"', pwdflags)/d
/ *and pwdchanged <= curdate() - interval coalesce(lft.wert+0,0) - coalesce(pw.wert+0,0) day,/d
/ *coalesce(lft.wert+0,0) - datediff(curdate(), pwdchanged), 0),/d
/%include logincheck.i2w/,/%include loginpage.i2w/s/pwdflags, \(.*\), wrongpwd, @sessid:=sessions.ID/\1/
/ *join sessions/d
/ *on sessions.userID = user.ID and sessions.sessionid/d
/ *and (updated > unix_timestamp() - 100000 OR find_in_set('"'staylogon', pwdflags))/d
/ *left join systemvars as lft on lft.name = 'pwdlifetime'/d
/ *left join systemvars as pw on pw.name = 'pwdexpirewarn'"'/d
s/\( *%if \)\$login$/\1%hpar('"'$remoteuser') = ''/"'
s/ *%include logincheck.i2w$/Error: No remote User\n%exit/
s/ *%include loginpage.i2w$/%'"'user not found': %hpar('$remoteuser')/"'
/ *%mysqlwrite("update sessions set updated = unix_timestamp() where ID = @sessid and userID = @userid")/d' login.i2w
  sed -i '/%include logincheck.i2w/,/%include loginpage.i2w/s/%cpar('"'username')/%hpar('$remoteuser')/"'
/%include logincheck.i2w/,/%include loginpage.i2w/s/, @sessid:=sessions.ID//
/ *join sessions/d
s/\( *%if \)\$login$/\1%hpar('"'$remoteuser') = ''/"'
s/ *%include logincheck.i2w$/Error: No remote User\n%exit/
s/ *%include loginpage.i2w$/%'"'user not found': %hpar('$remoteuser')/"'
/ *%mysqlwrite("update sessions set updated = unix_timestamp() where ID = @sessid and userID = @userid")/d' admin/loginr.i2w
  sed -i '/%link:mright change_pwd.u2w;/d
/%link:_top login.u2w;/d' index_admin.u2w operator/index.u2w admin/index.u2w
  sed -i 's#%hlink("/index.u2w",#%hlink("../index.u2w",#' operator/head.?2w admin/head.?2w
  #
  if [[ "$httpm" = "https" ]]; then
    u2wcfg=/etc/unix2web/uls443.conf
  else
    u2wcfg=/etc/unix2web/uls80.conf
  fi
  #
  sed '/^U2WHOME=/s/user$/ulssso/
s/^U2WPORT=.*/U2WPORT=11974/
s| -o | -op ${ULSBASE:-/srv}/uls/ssohosts.lst |
s| -lp [^ ]*| -lp /tmp/uls-sso.log|' $u2wcfg >/etc/unix2web/uls_sso.conf
  #
  systemctl enable unix2web@uls_sso
  systemctl restart unix2web@uls_sso
  #
  echo
  echo "Auf dem Proxy muss folgendes eingetragen werden:"
  echo "$httpm://$(hostname -f):11974/"
  echo "Bzw. mit der IP-Adresse"
else
  echo "Kann nicht ins Verzeichnis ${U2WHOME%user}ulssso wechseln."
  echo "Abbruch"
fi
