#!/bin/bash
#
# inst_check.sh
#
# Ueberprueft einige Voraussetzungen fuer die Installation
##########################################################
#
MINU2WV=9
MINU2WVM=7
MINU2WVMM=5
#
MYSQLDEFAULTS="$1"
ULSDIR="$2"
#
if unix2webd -v 2>&1 | egrep -q 'https .*mariadbclient|https .*mysqlclient'; then
  read U2WV U2WVM U2WVMM < <(unix2webd -v 2>&1 | head -1 | sed 's/.*Version \([0-9]*\)\.\([0-9]*\)[.-]\([0-9]*\), .*/\1 \2 \3/')
  if [[ $U2WV -lt $MINU2WV ]]; then
    echo "Es sind mindestens u2webtools_mysql oder u2webtools_mariadb in der Version $MINU2WV.$MINU2WVM.$MINU2WVMM notwendig."
    exit 1
  elif [[ $U2WV -eq $MINU2WV && $U2WVM -lt $MINU2WVM ]]; then
    echo "Es sind mindestens u2webtools_mysql oder u2webtools_mariadb in der Version $MINU2WV.$MINU2WVM.$MINU2WVMM notwendig."
    exit 1
  elif [[ $U2WV -eq $MINU2WV && $U2WVM -eq $MINU2WVM && $U2WVMM -lt $MINU2WVMM ]]; then
    echo "Es sind mindestens u2webtools_mysql oder u2webtools_mariadb in der Version $MINU2WV.$MINU2WVM.$MINU2WVMM notwendig."
    exit 1
  fi
else
  echo "u2webtools mit MariaDB oder MySQL Unterstützung nicht gefunden"
  exit 1
fi
