#!/bin/bash
#
# installuls.sh
#
# Datenbank des ULS (Universal Logging Systems)
# einrichten
###############################################
#
if [[ -z "$1" ]]
 then
  echo "Datenbank initialisieren, es wird ggf. nach dem root-Kennwort"
  echo " der MySQL-Installation gefragt."
  MYSQLP="mysql -u root -p"
else
  MYSQLP="mysql --defaults-extra-file=$1"
fi
#
if [[ -f "$ULSBASE/uls/database.conf" ]]
 then
  . "$ULSBASE/uls/database.conf"
else
  mkdir -p "$ULSBASE/uls"
  LOGGINGPWD=`tr -Cd '[:alnum:],;.:_+*~?=/!' </dev/urandom | head -c 12`
  LOGGINGADMINPWD=`tr -Cd '[:alnum:],;.:_+*~?=/!' </dev/urandom | head -c 12`
  LOGGINGLESENPWD=`tr -Cd '[:alnum:],;.:_+*~?=/!' </dev/urandom | head -c 12`
  LOGGINGTESTPWD=`tr -Cd '[:alnum:],;.:_+*~?=/!' </dev/urandom | head -c 12`
  echo "LOGGINGHOST='localhost'
LOGGINGPWD='$LOGGINGPWD'

LOGGINGADMINHOST='localhost'
LOGGINGADMINPWD='$LOGGINGADMINPWD'

LOGGINGLESENHOST='localhost'
LOGGINGLESENPWD='$LOGGINGLESENPWD'

LOGGINGTESTHOST='localhost'
LOGGINGTESTPWD='$LOGGINGTESTPWD'" >"$ULSBASE/uls/database.conf"
  chmod 640 "$ULSBASE/uls/database.conf"
  chown uls:ulsuser "$ULSBASE/uls/database.conf"
  echo "# Hosts and password for DB-Connection

# User 'logging': store data from clients
logginghost = 'localhost'
loggingpwd = '$LOGGINGPWD'

# User 'logginglesen': User menu
logginglesenhost = 'localhost'
logginglesenpwd = '$LOGGINGLESENPWD'

# User 'loggingadmin': Admin menu
loggingadminhost = 'localhost'
loggingadminpwd = '$LOGGINGADMINPWD'

# User 'loggingtest': check limits
loggingtesthost = 'localhost'
loggingtestpwd = '$LOGGINGTESTPWD'" >"$ULSBASE/uls/u2w.conf"
  chmod 640 "$ULSBASE/uls/u2w.conf"
  chown uls:ulsuser "$ULSBASE/uls/u2w.conf"
fi
#
if [[ -z "$LOGGINGPWD" || -z "$LOGGINGADMINPWD" || -z "$LOGGINGLESENPWD" || -z "$LOGGINGTESTPWD" ]]
 then
  echo "Error: missing Password in '$ULSBASE/uls/database.conf'"
  exit 1
fi
#
echo
echo "Create ULS-Databases and Tables"
if ! $MYSQLP <uls_create_db.sql
 then
  echo "Error on creating Databases and Tables"
  exit 1
fi
#
echo
echo "ULS-User and grants"
if ! sed "/^\$/d;s'LOGGINGPASSWORD'$LOGGINGPWD';s'LOGGINGADMINPASSWORD'$LOGGINGADMINPWD';s'LOGGINGLESENPASSWORD'$LOGGINGLESENPWD';s'LOGGINGTESTPASSWORD'$LOGGINGTESTPWD'" uls_grants.sql | $MYSQLP logging
 then
  echo "Error on creating Databases and Tables"
  exit 1
fi
