/****************************************/
/* file2ulsdb.h                         */
/*                                      */
/* Programm zur Einsortierung der Werte */
/* in die ULS-Datenbank                 */
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <dirent.h>

#ifdef MARIADBCLIENT
#include <mariadb/mysql.h>
#endif

#ifdef MYSQLCLIENT
#include <mysql/mysql.h>
#endif

#define false 0
#define true !false

#define MAX_ZEILENLAENGE    65000
#define MAX_LEN_SEND_LINE MAX_ZEILENLAENGE
#define MAX_LEN_READ_LINE    1024
#define MAX_MODE_LEN           10
#define MAX_DATETIME_LEN       40
#define MAX_TZ_LEN              8
#define MAX_SERVER_LEN        100
#define MAX_SECTION_LEN      1000
#define MAX_TESTSTEP_LEN     1000
#define MAX_DETAIL_LEN       1000
#define MAX_WERT_LEN        32000
#define MAX_EXTRA_LEN        2000
#define MAX_EINHEIT_LEN      1000
#define MAX_ACCESS_LEN         30
#define MYSQL_PUFFERSIZE 10000000
#define MAX_FILENAME_LEN     4096

#define MAX_QUERY_LEN    32000
#define LENITEXT            30
#define LENWTAB             32

#define MODE_NORMAL 0
#define MODE_UNIQUE 1
#define MODE_NODUP  2

#define ULS_MYSQL_PORT 3306
#define ULS_MYSQL_HOST "localhost"
#define ULS_MYSQL_USER "wwwuls"
#define ULS_MYSQL_PWD  ""
#define ULS_MYSQL_DB   "logging"
#define ULS_MYSQL_CHARACTERSET "utf8"

#define ERROR_NO_INPUTFILE        0   /* Fehler ignorieren */
#define ERROR_NO_RIGHTS           0   /* auch ignorieren   */
#define ERROR_NOTHING_TO_SET      0
#define ERROR_NO_SERVER_AGAIN     0   /* gleicher Server wie vorher */
#define ERROR_MYSQL_CONNECT       1
#define ERROR_NO_SERVER           2
#define MAX_ERROR_SHOW_EVERY      2   /* Fehlernummern > 2 nur einmal zeigen */
#define ERROR_DATETIME_IN_FUTURE  4
#define ERROR_NO_DATETIME         4
#define ERROR_NO_STDE             8
#define ERROR_NO_ACCESS           8
#define ERROR_WERT               16
#define ERROR_NO_WID             32
#define ERROR_NO_WTAB            64
#define ERROR_WERTCOUNT         128
#define ERROR_STORE_BLOB        128
#define ERROR_FILE_OPEN          16
#define ERROR_FILE_NOT_FOUND     16
#define ERROR_SSTDOKU            16
#define ERROR_SERVERDOKU         16
#define ERROR_QUERY              16

#define skip_blanks(a) while(*a == ' ' || *a == '\t') (a)++
#define skip_to_blank(a) while(*a && *a != ' ' && *a != '\t') (a)++

#ifdef DEBUG
#define DOFKT(d,f) d ## f
#else
#define DOFKT(d,f) f
#endif


#include "mime_types.h"

void show_version(int buildflag);
