#!/bin/sh
#
# makebackup.sh
#
# Backup der mysql-Datenbank
########################################################################
#
DATE=`date '+%F'`
TIME=`date '+%H:%M:00'`
START=`date '+%F %T'`
SSEC=`date '+%s'`
#
if [ -f /etc/ulsserver.conf ]
 then
  . /etc/ulsserver.conf
fi
if [ -z "$ULSNAME" ]
 then
  ULSNAME=`hostname`
fi
#
WDIR=/ulsbackup
#
# /srv/uls sichern
cd /srv
tar cfz /$WDIR/`hostname`_srv_uls.tgz uls >>/$WDIR/`hostname`_makebackup.log
cd /
tar cfz /$WDIR/`hostname`_root.tgz root/* >>/$WDIR/`hostname`_makebackup.log
#
crontab -l >/$WDIR/`hostname`_crontab.lst
crontab -u uls -l >/$WDIR/`hostname`_crontab_uls.lst
#
#export PATH="$PATH:/usr/local/sccl"
#
#if [ `sccl_get_aktnode uls` = `hostname` ]
# then
#  exit 0
#fi
#
send_test_value -h "$ULSNAME" ULS Jobs Makebackup $DATE $TIME "Start $START" '{T}'
#
mysqldump --max_allowed_packet=70000000 --user=root --password=`cat /srv/uls/mysqlpwd.txt` --all-databases 2>/$WDIR/`hostname`_makebackup.log | gzip -9 >/$WDIR/`hostname`_databases.sql.gz
#
END=`date '+%F %T'`
DAUER=$(( `date '+%s'` - $SSEC ))
#
send_test_value -h "$ULSNAME" ULS Jobs Makebackup $DATE $TIME "Stop $END" '{T}'
send_test_value -h "$ULSNAME" ULS Jobs Makebackup $DATE $TIME "$DAUER" 's'
