#!/bin/bash
#
# makebackup.sh
#
# Backup der mysql-Datenbank
########################################################################
#
if [ -f /etc/uls.conf ]
 then
  . /etc/uls.conf
fi
if [ -z "$ULSNAME" ]
 then
  ULSNAME=ulsserver
fi
#
DATE=`date '+%F'`
TIME=`date '+%H:%M:00'`
START=`date '+%F %T'`
SSEC=`date '+%s'`
#
WDIR=/ulsbackup
#
# /usr/local sichern
cd /usr/local
tar cfz /$WDIR/`hostname`_usr_local.tgz . >>/$WDIR/`hostname`_makebackup.log
cd /
tar cfz /$WDIR/`hostname`_root.tgz root/* >>/$WDIR/`hostname`_makebackup.log
#
crontab -l >/$WDIR/`hostname`_crontab.lst
crontab -u uls -l >/$WDIR/`hostname`_crontab_uls.lst
#
if [ "`/usr/local/sccl/sccl_get_aktnode uls`" = `hostname` ]
 then
  exit 0
fi
#
/usr/local/bin/send_test_value -h $ULSNAME ULS Jobs Makebackup $DATE $TIME "Start $START" '{T}'
#
mysqldump --max_allowed_packet=70000000 --user=root --password=`cat /usr/local/uls/mysqlpwd.txt` --all-databases 2>/$WDIR/`hostname`_makebackup.log | gzip -9 >/$WDIR/`hostname`_databases.sql.gz
#
END=`date '+%F %T'`
DAUER=$(( `date '+%s'` - $SSEC ))
#
/usr/local/bin/send_test_value -h $ULSNAME ULS Jobs Makebackup $DATE $TIME "Stop $END" '{T}'
/usr/local/bin/send_test_value -h $ULSNAME ULS Jobs Makebackup $DATE $TIME "$DAUER" 's'
