#!/bin/bash
#
# ping_clients.sh
#
# alle Clients, die Daten von heute haben anpingen
#
###################################################
#
if [[ -f /etc/ulsserver.conf ]]
 then
  . /etc/ulsserver.conf
  #
  cd $(dirname $0)
  #
  if [[ -f ../database.conf ]]
   then
    . ../database.conf
  fi
  #
  if [[ -n "$PINGNETS" ]]
   then
    DT=`date '+%F %T%:z'`
    ULSDATA=/tmp/uls_ping.$$.uls
    MYSQLO="/usr/bin/mysql -h ${LOGGINGADMINHOST:-localhost} -B -N -u loggingtest -p$LOGGINGTESTPWD logging"
    #
    BD=`dirname $0`
    if [[ -z "$PINGUNIT" ]]
     then
      PINGUNIT='ms'
    fi
    echo "D;$DT;;${PINGSECTION:-@uls};${PINGTESTSTEP:-ping};${PINGDETAIL:-time};" >$ULSDATA
    export PINGUNIT PINGFAILTIME
    $MYSQLO -e "select fqdn, inet_ntoa(ip) from server join (select serverID from sectiondates join section on section.ID = sectiondates.sectionID and section.name not like '@%' where sectiondates.ldate = date(now() - interval 1 hour) group by serverID) as z on z.serverID = server.ID where state != 'inactive' and inet_ntoa(ip) regexp '$PINGNETS'" | while read fqdn ip
     do
      if ! ping -c 1 -w 5 -n -q $ip
       then
        ping -c 1 -w 10 -n -q $fqdn
      fi | sed -n "s|rtt min/avg/max/mdev = [0-9.]*/\\([0-9.]*\\)/[0-9.]*/[0-9.]* $PINGUNIT|V;;$fqdn;;;;\\1;$PINGUNIT;|p;s|.*packets transmitted, 0 received, 100% packet loss.*|V;;$fqdn;;;;$PINGFAILTIME;$PINGUNIT;|p" | tail -1 &
      disown
      sleep 0.005
    done >>$ULSDATA
    sleep 20
    $BD/../wwwbin/file2ulsdb $ULSDATA
    rm $ULSDATA
  else
    echo "No nets for pinging defined"
  fi
fi
