#!/bin/bash
#
# call_html2pdf.sh
#
# generate pdf from Reports
#
# usage: call_html2pdf.sh <size> <orientation> <outputfile> <url>
##################################################################
#
. $(dirname $(readlink -f $0))/../ulsreport.conf
#
ULSREPURLSTART="http://$ULSREPUSER:$ULSREPPWD@$ULSREPHOST/"
#
export PATH="/usr/local/bin:$PATH"
#
#########################################################################
#
# enable only on program
#
#########################################################################
# htmldoc
#htmldoc --webpage -t pdf14 --size "$1" --"$2" --header ... --footer t./ -f "$3" "$ULSREPURLSTART$4"
#
#########################################################################
# somehtml2pdf.py
#/usr/bin/python /usr/local/uls/wwwbin/somehtml2pdf.py --size "$1" --"$2" -f "$3" "$ULSREPURLSTART$4"
#
#########################################################################
# wkhtmltopdf
#  - install wkhtmltopdf static and xorg-x11-fonts
if [[ "$2" = "landscape" ]]
 then
  wkhtmltopdf --orientation Landscape --page-size "$1" --margin-left 20 --margin-bottom 15 --footer-font-size 10 --footer-left "`date '+%F %T'`" --footer-right '[page]/[topage]' --footer-spacing 5 "$ULSREPURLSTART$4" "$3" 2>/dev/null
else
  wkhtmltopdf --page-size "$1" --margin-left 20 --margin-bottom 15 --footer-left "`date '+%F %T'`" --footer-font-size 10 --footer-right '[page]/[topage]' --footer-spacing 5 "$ULSREPURLSTART$4" "$3" 2>/dev/null
fi
#
