#!/bin/bash
#
# call_mail.sh
#
# send mail with attachments (mailreports)
#
# usage: call_mail.sh <address> <cc> <cc-as-ret> <subject> <bodyfile> <attachments>
###################################################################################
#
MAIL=`which mail`
if [[ -z "$MAIL" ]]
 then
  MAIL=`which mailx`
  if [[ -z "$MAIL" ]]
   then
    MAIL=`which s-nail`
  fi
fi
SUBJECT=$(echo $4)
if [[ -n "$MAIL" ]]
 then
  MAILPRG=`readlink -e "$MAIL"`
  if [[ "$MAILPRG" == *s-nail || "$MAILPRG" == *mailx* && "$MAILPRG" != *bsd-mailx ]]
   then
    if [[ -n "$2" ]]
     then
      if [[ "$3" = "1" ]]
       then
        eval '$MAILPRG -c "$2" -r "$2" -s "$SUBJECT" '"$6"' "$1" <"$5"'
      else
        eval '$MAILPRG -c "$2" -s "$SUBJECT" '"$6"' "$1" <"$5"'
      fi
    else
      eval '$MAILPRG -s "$SUBJECT" '"$6"' "$1" <"$5"'
    fi
  else
    if [[ -n "$2" ]]
     then
      eval '$MAILPRG -c "$2" -s "$SUBJECT" "$1" <"$5"'
    else
      eval '$MAILPRG -s "$SUBJECT" "$1" <"$5"'
    fi
  fi
else
  echo "ERROR: No mail program found."
fi
