#!/bin/bash
#
# get_report_csvs_sep.sh
#
# read all csv data for one report with separation
#
# usage: get_report_csvs_sep.sh [-z <zipfilename>] <reportsid> <attachmentpath> [<serveraliasnames>]
##########################################################################################################
#
. $(dirname $(readlink -f $0))/../ulsreport.conf
#
unset ZIPFILE
#
if [[ "$1" = "-z" ]]
 then
  if which zip &>/dev/null
   then
    ZIPFILE="${2:-csv-files}"
    ZIPFILE="${ZIPFILE%.zip}.zip"
  fi
  shift 2
fi
#
if cd $2
 then
  httpget -s -u "$ULSREPUSER" -p "$ULSREPPWD" "$ULSREPHOST" "do_report_csvs_sep.s2w?reportsid=$1" | while read id lfnr seps sepname name
   do
    if [[ "$seps" = "-" ]]
     then
      fn="${name:-table}_$lfnr.csv"
      httpget -q -f "$fn" -u "$ULSREPUSER" -p "$ULSREPPWD" "$ULSREPHOST" "get_report_csv.s2w?reportsid=$1&id=$id&serveraliasnames=$3"
    else
      fn="${name:-table}_${lfnr}_$sepname.csv"
      httpget -q -f "$fn" -u "$ULSREPUSER" -p "$ULSREPPWD" "$ULSREPHOST" "get_report_csv.s2w?reportsid=$1&id=$id&serveraliasnames=$3&$seps"
    fi
    if [[ -s "$fn" ]]
     then
      if [[ -z "$ZIPFILE" ]]
       then
        echo "-a \"$fn\""
      fi
    else
      rm "$fn"
    fi
  done
  if [[ -n "$ZIPFILE" ]]
   then
    if ls *.csv &>/dev/null
     then
      zip "$ZIPFILE" *.csv &>/dev/null
      echo "-a \"$ZIPFILE\""
    fi
  fi
fi
