#!/bin/bash
#
# get_uls_proxy_clients.sh
#
# ULS-Clientliste fuer ULS Proxy bereitstellen
#
###############################################################################
#
MYSQL="/usr/bin/mysql -B -N -u logginglesen -plesenlogging logging"
#
PATH=/usr/bin:/usr/local/bin:/srv/uls/bin:$PATH
export PATH
#
PROXYIP=$1
#
case $PROXYIP in
  10.251.10.50) IPRX='^11[.]|,11[.]|^131[.]|,131[.]';;
  10.251.193.1) IPRX='^11[.]|,11[.]';;
  10.59.41.38) IPRX='^10[.]|,10[.]';;
  10.62.80.102) IPRX='^10[.]|,10[.]';;
  *)           IPRX='';;
esac
#
if [[ -n "$IPRX" ]]
 then
  $MYSQL -e "
select lower(servername), lower(fqdn), inet_ntoa(server.ip), inet_ntoa(transferip), uls_werte_ips, sin, verfahren.name, seriennummer,
  replace(server.contact, '\\n', ' '), replace(server.location, '\\n', ' '), replace(server.beschreibung, '\\n', ' '),
  replace(server.maintenancewindow, '\\n', ' '),
  coalesce(max(if(zeitvon != '00:00:00' OR zeitbis != '23:59:59',
                  cast(unix_timestamp(least(datumbis, concat(curdate(), ' ', zeitbis))) as integer),
                  unix_timestamp(datumbis))), 0) as suspendend
from server
left join verfahren on verfahren.ID = server.verfahrenID
left join serverclasses on serverclasses.ID = server.serverclassesID
left join ueberwachungspausen as up
  on up.verfahrenID = server.verfahrenID
    and testreg(coalesce(serverclasses.name, ''), classes, classes_v)
    and testreg(server.servername, server, server_v)
    and (section = '.*' OR section = '^.*$') and section_v = ''
    and (teststep = '.*' OR teststep = '^.*$') and teststep_v = ''
    and (details = '.*' OR details = '^.*$') and details_v = ''
    and (einheit = '.*' OR einheit = '^.*$') and einheit_v = ''
    and datumvon <= now() and now() <= datumbis
    and if(mdaystart >= 0, mdaystart <= day(now()),
           month(curdate()) < month(curdate() - interval mdaystart day))
    and if(mdayend >= 0, day(curdate()) <= mdayend,
           month(curdate()) = month(curdate() - interval 1+mdayend day))
    and find_in_set(weekday(curdate()), weekdays)
    and zeitvon <= curtime() and curtime() <= zeitbis
where server.state != 'inactive' and (INET_NTOA(server.ip) regexp '$IPRX' OR INET_NTOA(transferip) regexp '$IPRX' OR uls_werte_ips regexp '$IPRX')
group by server.ID
order by servername"
fi
