#!/bin/bash
#
WD=`dirname $0`
if [[ -f $WD/../database.conf ]]
 then
  . $WD/../database.conf
fi
MYSQL="$WD/mysql_sql -Q \\\\$%& -s ${LOGGINGLESENHOST:-localhost} -u logginglesen -p $LOGGINGLESENPWD"
#
# Aufruf:
# loggingout_csv.sh <wids> <lwids> <VBSQL> <zwids> <swids> <bwids> <cwids> <pwids>
#                     1       2       3       4       5       6       7       8
#                   <twids> <kwids> <von> <bis> <title> <sep> <timefmt> <decimalpoint>
#                      9      10     11    12     13     14      15          16
#
WD=`dirname $0`
#
SEP="${14}"
DTF="${15}"
DECPKT="${16}"
if [[ -n "${13}" ]]
 then
  echo "${13}"
fi
unset CV
if [[ "${DECPKT:-.}" != "." ]]
 then
  DCS="replace("
  DCE=",'.','$DECPKT')"
else
  unset DCS DCE
fi
( $MYSQL -c '\1' "select werteindizes.ID, einheiten.name from einheiten, teststepdetails, werteindizes where find_in_set(werteindizes.ID, '$1') and teststepdetailsID=teststepdetails.ID and einheiten.ID=einheitID order by find_in_set(werteindizes.ID, '$1')"
  $MYSQL -c '\1' "select concat('l', l.ID), (select e.name from einheiten as e where e.ID=if(g.einheitenID>0,g.einheitenID,einheitID)) from lwerteindizes as l, teststepdetails as t, groupfunctions as g where find_in_set(l.ID, '$2') and t.ID=teststepdetailsID and g.ID=groupfunctionsID order by find_in_set(l.ID, '$2')"
  $MYSQL -c '\1' "select concat('k', kombidetails.ID), einheiten.name from kombidetails, teststepdetails, einheiten where find_in_set(kombidetails.ID, '${10}') and teststepdetails.ID=teststepdetailsID and einheiten.ID=einheitID order by find_in_set(kombidetails.ID, '${10}')"
  unset QUERY
  if [[ -n "$4" ]]
   then
    QUERY="select datum, werteindizesID, ${DCS}wert${DCE}, 1 as ID, date_format(datum, '$DTF') as d from zwerte where werteindizesID in ($4) $3"
  fi
  if [[ -n "$5" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select datum, werteindizesID, wert, ID, date_format(datum, '$DTF') as d from swerte where werteindizesID in ($5) $3"
  fi
  if [[ -n "$6" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select datum, werteindizesID, dateiname as wert, ID, date_format(datum, '$DTF') as d from bwerte where werteindizesID in ($6) $3"
  fi
  if [[ -n "$7" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select datum, werteindizesID, wert, 1 as ID, date_format(datum, '$DTF') as d from cwerte where werteindizesID in ($7) $3"
  fi
  if [[ -n "$8" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select datum, werteindizesID, ${DCS}wert${DCE}, 1 as ID, date_format(datum, '$DTF') as d from pwerte where werteindizesID in ($8) $3"
  fi
  if [[ -n "$9" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select trimdate(datum) as datum, werteindizesID, ${DCS}wert${DCE}, ID, date_format(datum, '$DTF') as d from twerte where werteindizesID in ($9) $3"
  fi
  if [[ -n "${10}" ]]
   then
    for i in ${10//,/ }
     do
      for j in `$MYSQL "select constvars from kombidetails where ID='$i'"`
       do
        M=${j%:*}
        W=${j#*:}
        CV="${CV}select getwertvb('$W', '${11:-0001-01-01 00:00:00}', '${12:-9999-12-31 23:59:59}', '$M') into @$M$W;"
      done
      WID=`$MYSQL "select firstdetwiID from kombidetails where ID='$i'"`
      F="`$MYSQL \"select formelsql from kombidetails where ID='$i'\"`"
      STR=`$MYSQL "select stringflag from kombidetails where ID='$i'"`
      WTAB=`$MYSQL "select wtab from werteindizes, teststepdetails, einheiten where werteindizes.ID='$WID' and teststepdetails.ID=teststepdetailsID and einheiten.ID=einheitID"`
      if [[ "$STR" = "1" ]]
       then
        QUERY="$QUERY${QUERY+ union all }
select trimdate(datum) as datum, 'k$i', (select $F), 1 as ID, date_format(datum, '$DTF') as d from $WTAB where werteindizesID='$WID' $3"
      else
        R=`$MYSQL "select length(wert)-1 as l from $WTAB where werteindizesID=$WID $3 order by l desc limit 1"`
        QUERY="$QUERY${QUERY+ union all }
select trimdate(datum) as datum, 'k$i', ${DCS}sround((select $F), $R)${DCE}, 1 as ID, date_format(datum, '$DTF') as d from $WTAB where werteindizesID='$WID' $3"
      fi
    done
  fi
  if [[ -n "$2" ]]
   then
    QUERY="$QUERY${QUERY+ union all }
select datum, concat('l', lwerteindizesID), ${DCS}wert${DCE}, 1 as ID, date_format(datum, '$DTF') as d from lwerte where lwerteindizesID in ($2) $3
union all
select datum, concat('l', lwerteindizesID), wert, 1 as ID, date_format(datum, '$DTF') as d from mwerte where lwerteindizesID in ($2) $3"
  fi
  $MYSQL -c '\1' -n ' ' "$CV$QUERY order by datum, ID"
) | awk -v SEP="$SEP" -F '\1' -f $WD/loggingout_csv.awk
