#!/bin/bash
#
WD=`dirname $0`
export PATH=$WD:/usr/local/bin:/usr/bin:$PATH
#
if [[ -f $WD/../database.conf ]]
 then
  . $WD/../database.conf
fi
MYSQL="mysql_sql -s ${LOGGINGLESENHOST:-localhost} -u logginglesen -p $LOGGINGLESENPWD"
#
#echo "$0 $*" >/tmp/lh.out
#echo "$0 '$1' '$2' '$3' '$4' '$5' '$6' '$7' '$8' '$9' '${10}' '${11}' '${12}' '${13}' '${14}' '${15}' '${16}' '${17}' '${18}' '${19}' '${20}'" >/tmp/lh.out
#
VON=$1
BIS=$2
WIDS=$3
LWIDS=$4
SIZE=${5/x/,}
AUSGABE=$6
ZVON=$7
ZBIS=$8
#
if [[ -z "$VON" ]]
 then
  VON="0000-00-00 00:00:00"
fi
if [[ -z "$BIS" ]]
 then
  BIS="9999-12-31 23:59:59"
fi
if [[ -n "${10}" && -n "${11}" || -n "$9$ZVON$ZBIS" ]]
 then
  if [[ -z "$ZVON" ]]
   then
    ZVON="00:00:00"
  fi
  if [[ -z "$ZBIS" ]]
   then
    ZBIS="24:00:00"
  fi
  ZSELF="extfilter"
  ZSELZ=", '$ZVON', '$ZBIS', '${9}', '${10}', '${11}', '${12}', '${13}', '${14}', '${15}', '${16}', '${17}', '${18}', '${19}', '${20}'"
else
  if [[ -z "$ZVON" && -z "$ZBIS" ]]
   then
    ZSELF=""
    ZSELZ=""
  else
    ZSELF="filter"
    ZSELZ=", '$ZVON', '$ZBIS'"
  fi
fi
#
SORT=${21}
Y1MIN=${22}
Y1MAX=${23}
# 
WERTE=/tmp/ulswerte$$.
#
ORDER=""
NAMES=''
LNAMES=''
#
if [[ "${24}" = "1" ]]
 then
  servername='aliasname'
else
  servername='servername'
fi
#
if [[ -n "$WIDS" ]]
 then
  E1=`$MYSQL "select einheiten.name from werteindizes, teststepdetails, einheiten where find_in_set(werteindizes.ID, '$WIDS') and teststepdetailsID=teststepdetails.ID and einheiten.ID=einheitID limit 1"`
  if [[ `$MYSQL "select count(distinct serverid) from werteindizes where find_in_set(ID, '$WIDS')"` -eq 1 ]]
   then
    SRVNAME=`$MYSQL "select $servername from server, werteindizes where find_in_set(werteindizes.ID, '$WIDS') and serverID=server.ID limit 1"`
  else
    SRVNAME=""
  fi
  #
  if [[ `$MYSQL "select count(distinct sectionID) from werteindizes where find_in_set(werteindizes.ID, '$WIDS')"` -eq 1 ]]
   then
    SECNAME=" / "`$MYSQL "select name from section, werteindizes where find_in_set(werteindizes.ID, '$WIDS') and sectionID=section.ID limit 1"`
  fi
  #
  if [[ `$MYSQL "select count(distinct teststepID) from werteindizes where find_in_set(werteindizes.ID, '$WIDS')"` -eq 1 ]]
   then
    TTNAME=" / "`$MYSQL "select name from teststep, werteindizes where find_in_set(werteindizes.ID, '$WIDS') and teststepID=teststep.ID limit 1"`
  fi
  #
  if [[ `$MYSQL "select count(distinct teststepdetailsID) from teststepdetails, werteindizes where werteindizes.ID, '$WIDS')"` -eq 1 ]]
   then
    DETNAME=" / "`$MYSQL "select name from teststepdetails, werteindizes where find_in_set(werteindizes.ID, '$WIDS') and teststepdetailsID=teststepdetails.ID limit 1"`
  fi
fi
#
if [[ -n "$LWIDS" ]]
 then
  if [[ `$MYSQL "select count(distinct serverID) from lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID"` -eq 1 ]]
   then
    LSRVNAME=`$MYSQL "select $servername from server, lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID and serverID=server.ID limit 1"`
  else
    LSRVNAME=""
  fi
  #
  if [[ `$MYSQL "select count(distinct sectionID) from lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID"` -eq 1 ]]
   then
    LSECNAME=" / "`$MYSQL "select name from section, lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID and sectionID=section.ID limit 1"`
  fi
  #
  if [[ `$MYSQL "select count(distinct teststepID) from teststep, lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID"` -eq 1 ]]
   then
    LTTNAME=" / "`$MYSQL "select name from teststep, lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID and teststepID=teststep.ID limit 1"`
  fi

  if [[ -z "$WIDS" ]]
   then
    SRVNAME=$LSRVNAME
    SECNAME=$LSECNAME
    TTNAME=$LTTNAME
    if [[ `$MYSQL "select count(distinct teststepdetailsID, groupfunctionsID, period) from lwerteindizes, werteindizes where find_in_set(lwerteindizes.ID, '$LWIDS') and werteindizesID=werteindizes.ID"` -eq 1 ]]
     then
      DETNAME=" / "`$MYSQL "select concat(ltext(groupfunctions.nameID), '[', left(period,1), '](', replace(teststepdetails.name, '\"',''), ')') from lwerteindizes join werteindizes on werteindizes.ID = werteindizesID join teststepdetails on teststepdetails.ID = teststepdetailsID join groupfunctions on groupfunctions.ID = groupfunctionsID where find_in_set(lwerteindizes.ID, '$LWIDS') limit 1"`
    fi
  fi
fi
#
if [[ -n "$WIDS" && -n "$LWIDS" ]]
 then
  if [[ "$LSRVNAME" != "$SRVNAME" ]]
   then
    SRVNAME=""
  fi
  if [[ "$SECNAME" != "$LSECNAME" ]]
   then
    SECNAME=""
  fi
  if [[ "$TTNAME" != "$LTTNAME" ]]
   then
    TTNAME=""
  fi
  DETNAME=""
fi
#
if [[ -z "$SRVNAME" ]]
 then
  ORDER="server.$servername"
  NAMES="server.$servername"
fi
if [[ -z "$SECNAME" ]]
 then
  if [[ -z "$ORDER" ]]
   then
    ORDER="section.name"
    NAMES="section.name"
  else
    ORDER="$ORDER, section.name"
    NAMES="$NAMES, '/', section.name"
  fi
fi
if [[ -z "$TTNAME" ]]
 then
  if [[ -z "$ORDER" ]]
   then
    ORDER="teststep.name"
    NAMES="teststep.name"
  else
    ORDER="$ORDER, teststep.name"
    NAMES="$NAMES, '/', teststep.name"
  fi
fi
if [[ -z "$DETNAME" ]]
 then
  if [[ -z "$ORDER" ]]
   then
    ORDER="teststepdetails.name"
    NAMES="teststepdetails.name"
    LNAMES="ltext(groupfunctions.nameID), '[', left(period,1), '](', replace(teststepdetails.name, '\"',''), ')'"
  else
    ORDER="$ORDER, teststepdetails.name"
    NAMES="$NAMES, '/', teststepdetails.name"
    LNAMES="$NAMES, '/', ltext(groupfunctions.nameID), '[', left(period,1), '](', replace(teststepdetails.name, '\"',''), ')'"
  fi
else
  LNAMES=$NAMES
fi
if [[ -z "$ORDER" ]]
 then
  ORDER="teststepdetails.name"
  NAMES="teststepdetails.name"
fi
#
if [[ "$AUSGABE" = "histgrad" ]]
 then
  EH1="$E1/h"
elif [[ "$AUSGABE" = "histcount" ]]
 then
  EH1=""
else
  EH1="$E1"
fi
#
if [[ $SORT = 'W' ]]
 then
  ORDER='v+0 desc'
elif [[ $SORT = 'V' ]]
 then
  ORDER='v+0'
fi
#
( cat `dirname $0`/loggingout_grafik_prescript.plt
  cat <<EOF
set terminal png size ${SIZE:-"800,600"}
set title "$SRVNAME$SECNAME$TTNAME$DETNAME"
set output
set key below
set style data histogram
set style histogram cluster gap 1
set style fill solid border -1
set boxwidth 0.9
set xtics rotate
set datafile separator "\t"
EOF
#
  echo "set ylabel \"$EH1\""
  echo "set xzeroaxis"
  #
  #
if [[ -n "$WIDS" ]]
 then
  case "$AUSGABE" in
    histmin) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'min'$ZSELZ)"
             TITLE="Min"
      ;;
    histmax) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'max'$ZSELZ)"
             TITLE="Max"
      ;;
    histavg) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'avg'$ZSELZ)"
             TITLE="Avg"
      ;;
    histstd) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'std'$ZSELZ)"
             TITLE="Std"
      ;;
    histsum) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'sum'$ZSELZ)"
             TITLE="Sum"
      ;;
    histmax-min) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'max-min'$ZSELZ)"
                 TITLE="Max-Min"
      ;;
    histlast-first) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'last-first'$ZSELZ)"
                    TITLE="Last-First"
      ;;
    histcount) SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'count'$ZSELZ)"
               TITLE="Count"
      ;;
    histgrad) SELECT="gradientvb$ZSELF(werteindizes.ID, '$VON', '$BIS'$ZSELZ)"
              TITLE="Grad"
      ;;
    *)
      if [[ -z "$VON" && -z "$BIS" && -z "$ZSELF" ]]
       then
        SELECT="lastwert"
        FROM="letztewerte,"
      else
        SELECT="getwertvb$ZSELF(werteindizes.ID, '$VON', '$BIS', 'last'$ZSELZ)"
        FROM=""
      fi
      TITLE="Letzter Wert"
      ;;
  esac
  echo -e "$TITLE\t" >${WERTE}E1.dat

  if [[ -n "$Y1MIN" || -n "$Y1MAX" ]]
   then
    echo "set yrange [${Y1MIN:-*}:${Y1MAX:-*}]"
  else
    MGN=`$MYSQL "select min($SELECT) > 0 from $FROM werteindizes where find_in_set(werteindizes.ID, '$WIDS')"`
    if [[ "$MGN" = "1" ]]
     then
      echo "set yrange [0:*]"
    else
      MKN=`$MYSQL "select max($SELECT) < 0 from $FROM werteindizes where find_in_set(werteindizes.ID, '$WIDS')"`
      if [[ "$MKN" = "1" ]]
       then
        echo "set yrange [*:0]"
      fi
    fi
  fi

  if [[ "`gnuplot --version | cut -d ' ' -f 2`" > "4.2" ]]
   then
    $MYSQL -n " " -c "\t" "select $SELECT as v, concat($NAMES) from werteindizes, $FROM server, section, teststep, teststepdetails where werteindizes.ID in ($WIDS) and serverID=server.ID and sectionID=section.ID and teststepID=teststep.ID and teststepdetailsID=teststepdetails.ID group by werteindizes.ID order by $ORDER" >>${WERTE}E1.dat
  else
    $MYSQL -n " " -c "\t" "select $SELECT as v, concat($NAMES) from werteindizes, $FROM server, section, teststep, teststepdetails where werteindizes.ID in ($WIDS) and serverID=server.ID and sectionID=section.ID and teststepID=teststep.ID and teststepdetailsID=teststepdetails.ID group by werteindizes.ID order by $ORDER" | sed 's/%/%%/g' >>${WERTE}E1.dat
  fi
elif [[ -n "$LWIDS" ]]
 then
  case "$AUSGABE" in
    histmin) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'min'$ZSELZ)"
             TITLE="Min"
      ;;
    histmax) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'max'$ZSELZ)"
             TITLE="Max"
      ;;
    histavg) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'avg'$ZSELZ)"
             TITLE="Avg"
      ;;
    histstd) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'std'$ZSELZ)"
             TITLE="Std"
      ;;
    histsum) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'sum'$ZSELZ)"
             TITLE="Sum"
      ;;
    histmax-min) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'max-min'$ZSELZ)"
                 TITLE="Max-Min"
      ;;
    histlast-first) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'last-first'$ZSELZ)"
                    TITLE="Last-First"
      ;;
    histcount) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'count'$ZSELZ)"
               TITLE="Count"
      ;;
    histgrad) SELECT="gradientlvbextfilter(lwerteindizes.ID, '$VON', '$BIS', '$ZVON', '$ZBIS', '${9}', '${10}', '${11}', '${12}', '${13}', '${14}', '${15}', '${16}', '${17}', '${18}', '${19}', '${20}')"
              TITLE="Grad"
      ;;
    *) SELECT="getlwertvb$ZSELF(lwerteindizes.ID, '$VON', '$BIS', 'last'$ZSELZ)"
       TITLE="Letzter Wert"
      ;;
  esac
  echo -e "$TITLE\t" >${WERTE}E1.dat

  if [[ -n "$Y1MIN" || -n "$Y1MAX" ]]
   then
    echo "set yrange [${Y1MIN:-*}:${Y1MAX:-*}]"
    echo "set y2range [${Y1MIN:-*}:${Y1MAX:-*}]"
  else
    MGN=`$MYSQL "select min($SELECT) > 0 from lwerteindizes where find_in_set(lwerteindizes.ID, '$LWIDS')"`
    if [[ "$MGN" = "1" ]]
     then
      echo "set yrange [0:*]"
    else
      MKN=`$MYSQL "select max($SELECT) < 0 from lwerteindizes where find_in_set(lwerteindizes.ID, '$LWIDS')"`
      if [[ "$MKN" = "1" ]]
       then
        echo "set yrange [*:0]"
      fi
    fi
  fi

  if [[ "`gnuplot --version | cut -d ' ' -f 2`" > "4.2" ]]
   then
    $MYSQL -n " " -c "\t" "select $SELECT as v, concat($LNAMES) from lwerteindizes, werteindizes, server, section, teststep, teststepdetails, groupfunctions where lwerteindizes.ID in ($LWIDS) and werteindizes.ID = werteindizesID and serverID=server.ID and sectionID=section.ID and teststepID=teststep.ID and teststepdetailsID=teststepdetails.ID and groupfunctions.ID = groupfunctionsID group by lwerteindizes.ID order by $ORDER" >>${WERTE}E1.dat
  else
    $MYSQL -n " " -c "\t" "select $SELECT as v, concat($LNAMES) from lwerteindizes, werteindizes, server, section, teststep, teststepdetails, groupfunctions where lwerteindizes.ID in ($LWIDS) and werteindizes.ID = werteindizesID and serverID=server.ID and sectionID=section.ID and teststepID=teststep.ID and teststepdetailsID=teststepdetails.ID and groupfunctions.ID = groupfunctionsID group by lwerteindizes.ID order by $ORDER" | sed 's/%/%%/g' >>${WERTE}E1.dat
  fi
fi
#
echo "plot \"${WERTE}E1.dat\" using 1:xtic(2) ti col"
#
#echo "SELECT: $SELECT, NAMES: $NAMES, ORDER: $ORDER, WIDS: $WIDS, MGN: $MGN, MKN: $MKN." >/tmp/sel.lst
#
) | gnuplot 2>/dev/null || cat "$WD/no_data_found.png"
#
rm -rf ${WERTE}*.dat
