#!/bin/bash
#
# personal_mail.sh
#
# send personal mail
#
# usage: personal_mail.sh <address> <returnaddress> <subject> <body>
#
# <subject> sollte keine Umlaute enhalten
#  und nicht laenger als 43 Zeichen sein.
#####################################################################
#
MAIL=`which mail`
if [[ -z "$MAIL" ]]
 then
  MAIL=`which mailx`
  if [[ -z "$MAIL" ]]
   then
    MAIL=`which s-nail`
  fi
fi
if [[ -n "$MAIL" ]]
 then
  MAILPRG=`readlink -e "$MAIL"`
  if [[ "$MAILPRG" == *s-nail || "$MAILPRG" == *mailx* && "$MAILPRG" != *bsd-mailx ]]
   then
    SUBJECT="$(echo $3 | iconv -c --from-code=UTF-8 --to-code=ASCII//TRANSLIT | cut -c-43)"
    if [[ -n "$2" ]]
     then
      eval 'echo "$4" | $MAILPRG -r "$2" -s "$SUBJECT
Sensitivity: personal" "$1"'
    else
      eval 'echo "$4" | $MAILPRG -s "$SUBJECT
Sensitivity: personal" "$1"'
    fi
  else
    eval 'echo "$4" | $MAILPRG -s "$3" -a "Sensitivity: personal" "$1"'
  fi
else
  echo "ERROR: No mail program found."
fi
