#!/bin/bash
#
# send_mail.sh
#
# send mail with attachments
#
# usage: echo "BODY" | send_mail.sh <address> <subject> <attachments>
#
#####################################################################
#
MAIL=`which mail`
if [[ -z "$MAIL" ]]
 then
  MAIL=`which mailx`
  if [[ -z "$MAIL" ]]
   then
    MAIL=`which s-nail`
  fi
fi
SUBJECT=$(echo $2)
if [[ -n "$MAIL" ]]
 then
  MAILPRG=`readlink -e "$MAIL"`
  if [[ "$MAILPRG" == *s-nail || "$MAILPRG" == *mailx* && "$MAILPRG" != *bsd-mailx ]]
   then
    eval '$MAILPRG -s "$SUBJECT" '"$3"' "$1"'
  else
    eval '$MAILPRG -s "$SUBJECT" "$1"'
  fi
else
  echo "ERROR: No mail program found."
fi
