#!/bin/bash
#
# send_proxy_data.sh
#
# Werte der ULS-Clients vom ULS-Proxy annehmen
#
###############################################################################
#
TMPBASE=/tmp
#
export SLEEPTIME=0.3
#
PATH=/srv/uls/wwwbin:/usr/bin:/usr/local/bin:$PATH
export PATH
#
if [ -f /etc/ulsserver.conf ]
 then
  . /etc/ulsserver.conf
fi
#
WD=`dirname $0`
if [[ -f $WD/../database.conf ]]
 then
  . $WD/../database.conf
fi
CS=`/usr/bin/mysql -N -B -u "wwwuls" -e "select count(*) from swerte" logging`
if echo $CS | grep -q '^[0-9][0-9]*'
 then
  :
else
  echo "Error: no connection to Database"
  exit 1
fi
#
TMPPATH=$TMPBASE/ulsproxy.$$
#
function make_fp
{ ip=$1
  if cd $1
   then
    SEPPATH=T.$$
    ls | while read F
     do
      ( if mkdir $SEPPATH && cd $SEPPATH
         then
          fileunpack ../$F
          file2ulsdb -i $ip -D . 2>&1 | head -3
          cd ..
        fi
      )
      rm -r $SEPPATH 2>&1
      rm $F 2>&1
    done
    cd ..
  fi
  rmdir $1 2>&1
}
#
function make_fpz
{ ip=$1
  if cd $1
   then
    SEPPATH=T.$$
    ls | while read F
     do
      ( if mkdir $SEPPATH && cd $SEPPATH
         then
          zcat ../$F | fileunpack
          file2ulsdb -i $ip -D . 2>&1 | head -3
          cd ..
        fi
      )
      rm -r $SEPPATH 2>&1
      rm $F 2>&1
    done
    cd ..
  fi
  rmdir $1 2>&1
}
#
function make_tgz
{ ip=$1
  if cd $1
   then
    SEPPATH=T.$$
    ls | while read F
     do
      ( if mkdir $SEPPATH && cd $SEPPATH
         then
          tar xfz ../$F
          file2ulsdb -i $ip -D . 2>&1 | head -3
          cd ..
        fi
      )
      rm -r $SEPPATH 2>&1
      rm $F 2>&1
    done
    cd ..
  fi
  rmdir $1 2>&1
}
#
function make_tab
{ file2ulsdb -i $1 -D $1 2>&1 | head -3
  rm $1/* 2>&1
  rmdir $1 2>&1
}
#
echo mkdir -p $TMPPATH
if mkdir -p $TMPPATH && cd $TMPPATH
 then
  if tar xvfz "$1" 2>&1
   then
    if [[ -d TAB ]]
     then
      ( if cd TAB
         then
          ls | while read IP
           do
            if [[ -d $IP ]]
             then
              make_tab $IP
              ## sleep $SLEEPTIME
            fi
          done
        fi
      )
    fi
    if [[ -d FP ]]
     then
      ( if cd FP
         then
          ls | while read IP
           do
            if [[ -d $IP ]]
             then
              make_fp $IP
              ## sleep $SLEEPTIME
            fi
          done
        fi
      )
    fi
    if [[ -d FPZ ]]
     then
      ( if cd FPZ
         then
          ls | while read IP
           do
            if [[ -d $IP ]]
             then
              make_fpz $IP
              ## sleep $SLEEPTIME
            fi
          done
        fi
      )
    fi
    if [[ -d TGZ ]]
     then
      ( if cd TGZ
         then
          ls | while read IP
           do
            if [[ -d $IP ]]
             then
              make_tgz $IP
              ## sleep $SLEEPTIME
            fi
          done
        fi
      )
    fi
    cd ..
    sleep 10
    while [[ `find $TMPPATH -mindepth 2 -maxdepth 2 | wc -l` -gt 0 ]]
     do
      sleep 5
    done
    rmdir $TMPPATH/* 2>&1
  fi
  rmdir $TMPPATH 2>&1
fi
