#!/bin/bash
#
# empfangene "filepack"Datei auspacken und ULS-Daten speichern
##############################################################
#
WD=`dirname $0`
#
if [[ $# -lt 1 ]]
 then
  echo "usage: `basename $0` <Filepack-Datei> [-i <IP-Address>] [-s <ssl>]"
  exit 1
fi
#
if [[ "$2" = "-i" ]]
 then
  IP="_$3"
else
  IP=""
fi
#
if [[ -d /ulsdata && -w /ulsdata ]]
 then
  TMPPFAD=/ulsdata/ud${IP}_`date '+%H%M%S'`$$
else
  TMPPFAD=/tmp/ud${IP}_`date '+%H%M%S'`$$
fi
mkdir -p $TMPPFAD
if cd $TMPPFAD
 then
  if $WD/fileunpack $1
   then
    echo "OK"
    shift
    ( RET=0
      if ls | grep -q '\.uls$'
       then
        $WD/file2ulsdb "$@" -D .
        RET=$?
      fi
      cd ..
      if [[ $RET -eq 1 ]]
       then
        tar cfJ ${TMPPFAD}_err1.txz $TMPPFAD
      fi
      rm -rf $TMPPFAD
    ) >>/tmp/uls_store_test.log 2>&1 &
    exit 0
  fi
  echo "ERROR: Wrong fp-file."
  cd ..
  rm -rf $TMPPFAD
else
  echo "ERROR: Unable to create $TMPPFAD."
fi
