#!/bin/bash
#
# empfangene tabelle.uls -> ULS-Daten speichern
#######################################################
#
WD=`dirname $0`
#
if [[ $# -lt 1 ]]
 then
  echo "usage: `basename $0` <uls-tab> [-i <IP-Address>] [-s <ssl>]"
  exit 1
fi
#
if [[ "$2" = "-i" ]]
 then
  IP="_$3"
else
  IP=""
fi
#
if [[ -d /ulsdata && -w /ulsdata ]]
 then
  TMPPFAD=/ulsdata/ud${IP}_`date '+%H%M%S'`$$
else
  TMPPFAD=/tmp/ud${IP}_`date '+%H%M%S'`$$
fi
mkdir -p $TMPPFAD
if cd $TMPPFAD
 then
  DAT="$1"
  shift
  $WD/file2ulsdb "$@" "$DAT" 2>&1
  echo "OK"
  cd ..
  rm -r $TMPPFAD
else
  echo "ERROR: Unable to create $TMPPFAD."
fi
